use crate::parser::{tokenize, parse};
use crate::compiler::meta_compile;

#[test]
fn test_compile() {
    let src = "
(module Shader Logical GLSL450)
(import :std GLSL.std.450)
(bind (frag-coord:*v4f32i) (Builtin FragCoord))
(bind (out-color:*v4f32o) (Location 0))
(dec frag-coord:*v4f32i Input)
(dec out-color:*v4f32o Output)
(entry main Fragment OriginUpperLeft (:frag-coord :out-color))
(fun (main)
  (store-ptr (out-color)
    (v4f32i (/ (.xy (load-ptr frag-coord))
               (v2f32 1920.0 1080.0)) 
            1.0 
            1.0)))
";
    let mut ast = parse(tokenize(src));
    println!("{:?}", ast);
    let module = meta_compile(&mut ast);
    println!("{:?}", module);
}